gi-gdkpixbuf-2.0.32: GdkPixbuf bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GdkPixbuf.Objects.Pixbuf

Contents

- Exported types
- Methods
  - addAlpha
  - applyEmbeddedOrientation
  - calculateRowstride
  - composite
  - compositeColor
  - compositeColorSimple
  - copy
  - copyArea
  - copyOptions
  - fill
  - flip
  - getBitsPerSample
  - getByteLength
  - getColorspace
  - getFileInfo
  - getFileInfoAsync
  - getFileInfoFinish
  - getFormats
  - getHasAlpha
  - getHeight
  - getNChannels
  - getOption
  - getPixels
  - getRowstride
  - getWidth
  - initModules
  - new
  - newFromBytes
  - newFromData
  - newFromFile
  - newFromFileAtScale
  - newFromFileAtSize
  - newFromInline
  - newFromResource
  - newFromResourceAtScale
  - newFromStream
  - newFromStreamAsync
  - newFromStreamAtScale
  - newFromStreamAtScaleAsync
  - newFromStreamFinish
  - newFromXpmData
  - newSubpixbuf
  - readPixelBytes
  - readPixels
  - removeOption
  - rotateSimple
  - saturateAndPixelate
  - saveToBufferv
  - saveToCallbackv
  - saveToStreamFinish
  - saveToStreamv
  - saveToStreamvAsync
  - savev
  - scale
  - scaleSimple
  - setOption
- Properties
  - bitsPerSample
  - colorspace
  - hasAlpha
  - height
  - nChannels
  - pixelBytes
  - pixels
  - rowstride
  - width

Description

A pixel buffer.

`GdkPixbuf` contains information about an image's pixel data, its color space, bits per sample, width and height, and the rowstride (the number of bytes between the start of one row and the start of the next).

## Creating new `GdkPixbuf`

The most basic way to create a pixbuf is to wrap an existing pixel buffer with a `Pixbuf` instance. You can use the [`ctor@GdkPixbuf.Pixbuf.new_from_data`] function to do this.

Every time you create a new `GdkPixbuf` instance for some data, you will need to specify the destroy notification function that will be called when the data buffer needs to be freed; this will happen when a `GdkPixbuf` is finalized by the reference counting functions. If you have a chunk of static data compiled into your application, you can pass in `NULL` as the destroy notification function so that the data will not be freed.

The [`ctor@GdkPixbuf.Pixbuf.new`] constructor function can be used as a convenience to create a pixbuf with an empty buffer; this is equivalent to allocating a data buffer using `malloc()` and then wrapping it with `gdk_pixbuf_new_from_data()`. The `gdk_pixbuf_new()` function will compute an optimal rowstride so that rendering can be performed with an efficient algorithm.

You can also copy an existing pixbuf with the [method`pixbuf`.copy] function. This is not the same as just acquiring a reference to the old pixbuf instance: the copy function will actually duplicate the pixel data in memory and create a new [class`pixbuf`] instance for it.

## Reference counting

`GdkPixbuf` structures are reference counted. This means that an application can share a single pixbuf among many parts of the code. When a piece of the program needs to use a pixbuf, it should acquire a reference to it by calling `g_object_ref()`; when it no longer needs the pixbuf, it should release the reference it acquired by calling `g_object_unref()`. The resources associated with a `GdkPixbuf` will be freed when its reference count drops to zero. Newly-created `GdkPixbuf` instances start with a reference count of one.

## Image Data

Image data in a pixbuf is stored in memory in an uncompressed, packed format. Rows in the image are stored top to bottom, and in each row pixels are stored from left to right.

There may be padding at the end of a row.

The "rowstride" value of a pixbuf, as returned by [`method@GdkPixbuf.Pixbuf.get_rowstride`], indicates the number of bytes between rows.

NOTE: If you are copying raw pixbuf data with `memcpy()` note that the last row in the pixbuf may not be as wide as the full rowstride, but rather just as wide as the pixel data needs to be; that is: it is unsafe to do `memcpy (dest, pixels, rowstride * height)` to copy a whole pixbuf. Use `pixbufCopy` instead, or compute the width in bytes of the last row as:

### c code

    last_row = width * ((n_channels * bits_per_sample + 7) / 8);

The same rule applies when iterating over each row of a `GdkPixbuf` pixels array.

The following code illustrates a simple `put_pixel()` function for RGB pixbufs with 8 bits per channel with an alpha channel.

### c code

    static void
    put_pixel (GdkPixbuf *pixbuf,
               int x,
    	   int y,
    	   guchar red,
    	   guchar green,
    	   guchar blue,
    	   guchar alpha)
    {
      int n_channels = gdk_pixbuf_get_n_channels (pixbuf);

      // Ensure that the pixbuf is valid
      g_assert (gdk_pixbuf_get_colorspace (pixbuf) == GDK_COLORSPACE_RGB);
      g_assert (gdk_pixbuf_get_bits_per_sample (pixbuf) == 8);
      g_assert (gdk_pixbuf_get_has_alpha (pixbuf));
      g_assert (n_channels == 4);

      int width = gdk_pixbuf_get_width (pixbuf);
      int height = gdk_pixbuf_get_height (pixbuf);

      // Ensure that the coordinates are in a valid range
      g_assert (x >= 0 && x < width);
      g_assert (y >= 0 && y < height);

      int rowstride = gdk_pixbuf_get_rowstride (pixbuf);

      // The pixel buffer in the GdkPixbuf instance
      guchar *pixels = gdk_pixbuf_get_pixels (pixbuf);

      // The pixel we wish to modify
      guchar *p = pixels + y * rowstride + x * n_channels;
      p[0] = red;
      p[1] = green;
      p[2] = blue;
      p[3] = alpha;
    }

## Loading images

The `GdkPixBuf` class provides a simple mechanism for loading an image from a file in synchronous and asynchronous fashion.

For GUI applications, it is recommended to use the asynchronous stream API to avoid blocking the control flow of the application.

Additionally, `GdkPixbuf` provides the [class`gdkPixbuf`.PixbufLoader@] API for progressive image loading.

## Saving images

The `GdkPixbuf` class provides methods for saving image data in a number of file formats. The formatted data can be written to a file or to a memory buffer. @GdkPixbuf` can also call a user-defined callback on the data, which allows to e.g. write the image to a socket or store it in a database.

Synopsis

- newtype Pixbuf = Pixbuf (ManagedPtr Pixbuf)
- class (GObject o, IsDescendantOf Pixbuf o) => IsPixbuf o
- toPixbuf :: (MonadIO m, IsPixbuf o) => o -> m Pixbuf
- pixbufAddAlpha :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Bool -> Word8 -> Word8 -> Word8 -> m (Maybe Pixbuf)
- pixbufApplyEmbeddedOrientation :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m (Maybe Pixbuf)
- pixbufCalculateRowstride :: (HasCallStack, MonadIO m) => Colorspace -> Bool -> Int32 -> Int32 -> Int32 -> m Int32
- pixbufComposite :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> b -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> Double -> Double -> Double -> InterpType -> Int32 -> m ()
- pixbufCompositeColor :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> b -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> Double -> Double -> Double -> InterpType -> Int32 -> Int32 -> Int32 -> Int32 -> Word32 -> Word32 -> m ()
- pixbufCompositeColorSimple :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Int32 -> Int32 -> InterpType -> Int32 -> Int32 -> Word32 -> Word32 -> m (Maybe Pixbuf)
- pixbufCopy :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m (Maybe Pixbuf)
- pixbufCopyArea :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> Int32 -> Int32 -> Int32 -> Int32 -> b -> Int32 -> Int32 -> m ()
- pixbufCopyOptions :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> b -> m Bool
- pixbufFill :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Word32 -> m ()
- pixbufFlip :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Bool -> m (Maybe Pixbuf)
- pixbufGetBitsPerSample :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Int32
- pixbufGetByteLength :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m CSize
- pixbufGetColorspace :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Colorspace
- pixbufGetFileInfo :: (HasCallStack, MonadIO m) => [Char] -> m (Maybe PixbufFormat, Int32, Int32)
- pixbufGetFileInfoAsync :: (HasCallStack, MonadIO m, IsCancellable a) => [Char] -> Maybe a -> Maybe AsyncReadyCallback -> m ()
- pixbufGetFileInfoFinish :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m (Maybe PixbufFormat, Int32, Int32)
- pixbufGetFormats :: (HasCallStack, MonadIO m) => m [PixbufFormat]
- pixbufGetHasAlpha :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Bool
- pixbufGetHeight :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Int32
- pixbufGetNChannels :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Int32
- pixbufGetOption :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Text -> m (Maybe Text)
- pixbufGetPixels :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m ByteString
- pixbufGetRowstride :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Int32
- pixbufGetWidth :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Int32
- pixbufInitModules :: (HasCallStack, MonadIO m) => Text -> m ()
- pixbufNew :: (HasCallStack, MonadIO m) => Colorspace -> Bool -> Int32 -> Int32 -> Int32 -> m (Maybe Pixbuf)
- pixbufNewFromBytes :: (HasCallStack, MonadIO m) => Bytes -> Colorspace -> Bool -> Int32 -> Int32 -> Int32 -> Int32 -> m Pixbuf
- pixbufNewFromData :: (HasCallStack, MonadIO m) => Ptr Word8 -> Colorspace -> Bool -> Int32 -> Int32 -> Int32 -> Int32 -> Maybe PixbufDestroyNotify -> m Pixbuf
- pixbufNewFromFile :: (HasCallStack, MonadIO m) => [Char] -> m (Maybe Pixbuf)
- pixbufNewFromFileAtScale :: (HasCallStack, MonadIO m) => [Char] -> Int32 -> Int32 -> Bool -> m (Maybe Pixbuf)
- pixbufNewFromFileAtSize :: (HasCallStack, MonadIO m) => [Char] -> Int32 -> Int32 -> m (Maybe Pixbuf)
- pixbufNewFromInline :: (HasCallStack, MonadIO m) => ByteString -> Bool -> m Pixbuf
- pixbufNewFromResource :: (HasCallStack, MonadIO m) => Text -> m (Maybe Pixbuf)
- pixbufNewFromResourceAtScale :: (HasCallStack, MonadIO m) => Text -> Int32 -> Int32 -> Bool -> m (Maybe Pixbuf)
- pixbufNewFromStream :: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) => a -> Maybe b -> m (Maybe Pixbuf)
- pixbufNewFromStreamAsync :: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) => a -> Maybe b -> Maybe AsyncReadyCallback -> m ()
- pixbufNewFromStreamAtScale :: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) => a -> Int32 -> Int32 -> Bool -> Maybe b -> m (Maybe Pixbuf)
- pixbufNewFromStreamAtScaleAsync :: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) => a -> Int32 -> Int32 -> Bool -> Maybe b -> Maybe AsyncReadyCallback -> m ()
- pixbufNewFromStreamFinish :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m (Maybe Pixbuf)
- pixbufNewFromXpmData :: (HasCallStack, MonadIO m) => [Text] -> m (Maybe Pixbuf)
- pixbufNewSubpixbuf :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Int32 -> Int32 -> Int32 -> Int32 -> m Pixbuf
- pixbufReadPixelBytes :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Bytes
- pixbufReadPixels :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> m Word8
- pixbufRemoveOption :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Text -> m Bool
- pixbufRotateSimple :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> PixbufRotation -> m (Maybe Pixbuf)
- pixbufSaturateAndPixelate :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> b -> Float -> Bool -> m ()
- pixbufSaveToBufferv :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Text -> Maybe [Text] -> Maybe [Text] -> m ByteString
- pixbufSaveToCallbackv :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> PixbufSaveFunc -> Text -> Maybe [Text] -> Maybe [Text] -> m ()
- pixbufSaveToStreamFinish :: (HasCallStack, MonadIO m, IsAsyncResult a) => a -> m ()
- pixbufSaveToStreamv :: (HasCallStack, MonadIO m, IsPixbuf a, IsOutputStream b, IsCancellable c) => a -> b -> Text -> Maybe [Text] -> Maybe [Text] -> Maybe c -> m ()
- pixbufSaveToStreamvAsync :: (HasCallStack, MonadIO m, IsPixbuf a, IsOutputStream b, IsCancellable c) => a -> b -> Text -> Maybe [Text] -> Maybe [Text] -> Maybe c -> Maybe AsyncReadyCallback -> m ()
- pixbufSavev :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> [Char] -> Text -> Maybe [Text] -> Maybe [Text] -> m ()
- pixbufScale :: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) => a -> b -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> Double -> Double -> Double -> InterpType -> m ()
- pixbufScaleSimple :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Int32 -> Int32 -> InterpType -> m (Maybe Pixbuf)
- pixbufSetOption :: (HasCallStack, MonadIO m, IsPixbuf a) => a -> Text -> Text -> m Bool
- constructPixbufBitsPerSample :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getPixbufBitsPerSample :: (MonadIO m, IsPixbuf o) => o -> m Int32
- constructPixbufColorspace :: (IsPixbuf o, MonadIO m) => Colorspace -> m (GValueConstruct o)
- getPixbufColorspace :: (MonadIO m, IsPixbuf o) => o -> m Colorspace
- constructPixbufHasAlpha :: (IsPixbuf o, MonadIO m) => Bool -> m (GValueConstruct o)
- getPixbufHasAlpha :: (MonadIO m, IsPixbuf o) => o -> m Bool
- constructPixbufHeight :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getPixbufHeight :: (MonadIO m, IsPixbuf o) => o -> m Int32
- constructPixbufNChannels :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getPixbufNChannels :: (MonadIO m, IsPixbuf o) => o -> m Int32
- constructPixbufPixelBytes :: (IsPixbuf o, MonadIO m) => Bytes -> m (GValueConstruct o)
- getPixbufPixelBytes :: (MonadIO m, IsPixbuf o) => o -> m (Maybe Bytes)
- constructPixbufPixels :: (IsPixbuf o, MonadIO m) => Ptr () -> m (GValueConstruct o)
- getPixbufPixels :: (MonadIO m, IsPixbuf o) => o -> m (Ptr ())
- constructPixbufRowstride :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getPixbufRowstride :: (MonadIO m, IsPixbuf o) => o -> m Int32
- constructPixbufWidth :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getPixbufWidth :: (MonadIO m, IsPixbuf o) => o -> m Int32

# Exported types

newtype Pixbuf Source #

Memory-managed wrapper type.

Constructors

Pixbuf (ManagedPtr Pixbuf) |

#### Instances

Instances details

Eq Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf Methods (==) :: Pixbuf -> Pixbuf -> Bool Source # (/=) :: Pixbuf -> Pixbuf -> Bool Source #
GObject Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf
ManagedPtrNewtype Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf Methods toManagedPtr :: Pixbuf -> ManagedPtr Pixbuf Source #
TypedObject Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf Methods glibType :: IO GType Source #
HasParentTypes Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf
IsGValue (Maybe Pixbuf) Source # | Convert `Pixbuf` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Pixbuf -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Pixbuf) Source #
type ParentTypes Pixbuf Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf type ParentTypes Pixbuf = '[Object, Icon, LoadableIcon]

class (GObject o, IsDescendantOf Pixbuf o) => IsPixbuf o Source #

Type class for types which can be safely cast to `Pixbuf`, for instance with `toPixbuf`.

#### Instances

Instances details

(GObject o, IsDescendantOf Pixbuf o) => IsPixbuf o Source # |
Instance details Defined in GI.GdkPixbuf.Objects.Pixbuf

toPixbuf :: (MonadIO m, IsPixbuf o) => o -> m Pixbuf Source #

Cast to `Pixbuf`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addAlpha, applyEmbeddedOrientation, bindProperty, bindPropertyFull, composite, compositeColor, compositeColorSimple, copy, copyArea, copyOptions, equal, fill, flip, forceFloating, freezeNotify, getv, hash, isFloating, load, loadAsync, loadFinish, newSubpixbuf, notify, notifyByPspec, readPixelBytes, readPixels, ref, refSink, removeOption, rotateSimple, runDispose, saturateAndPixelate, saveToBufferv, saveToCallbackv, saveToStreamv, saveToStreamvAsync, savev, scale, scaleSimple, serialize, stealData, stealQdata, thawNotify, toString, unref, watchClosure.

#### Getters

getBitsPerSample, getByteLength, getColorspace, getData, getHasAlpha, getHeight, getNChannels, getOption, getOptions, getPixels, getProperty, getQdata, getRowstride, getWidth.

#### Setters

setData, setDataFull, setOption, setProperty.

## addAlpha

pixbufAddAlpha Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A `Pixbuf`.
-> Bool | `substituteColor`: Whether to set a color to zero opacity.
-> Word8 | `r`: Red value to substitute.
-> Word8 | `g`: Green value to substitute.
-> Word8 | `b`: Blue value to substitute.
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf

Takes an existing pixbuf and adds an alpha channel to it.

If the existing pixbuf already had an alpha channel, the channel values are copied from the original; otherwise, the alpha channel is initialized to 255 (full opacity).

If `substitute_color` is `TRUE`, then the color specified by the (`r`, `g`, `b`) arguments will be assigned zero opacity. That is, if you pass `(255, 255, 255)` for the substitute color, all white pixels will become fully transparent.

If `substitute_color` is `FALSE`, then the (`r`, `g`, `b`) arguments will be ignored.

## applyEmbeddedOrientation

pixbufApplyEmbeddedOrientation Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `src`: a pixbuf with an orientation option
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf

Takes an existing pixbuf and checks for the presence of an associated "orientation" option.

The orientation option may be provided by the JPEG loader (which reads the exif orientation tag) or the TIFF loader (which reads the TIFF orientation tag, and compensates it for the partial transforms performed by libtiff).

If an orientation option/tag is present, the appropriate transform will be performed so that the pixbuf is oriented correctly.

Since: 2.12

## calculateRowstride

pixbufCalculateRowstride Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Colorspace | `colorspace`: Color space for image
-> Bool | `hasAlpha`: Whether the image should have transparency information
-> Int32 | `bitsPerSample`: Number of bits per color sample
-> Int32 | `width`: Width of image in pixels, must be > 0
-> Int32 | `height`: Height of image in pixels, must be > 0
-> m Int32 | Returns: the rowstride for the given values, or -1 in case of error.

Calculates the rowstride that an image created with those values would have.

This function is useful for front-ends and backends that want to check image values without needing to create a `GdkPixbuf`.

Since: 2.36.8

## composite

pixbufComposite Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `src`: a `Pixbuf`
-> b | `dest`: the `Pixbuf` into which to render the results
-> Int32 | `destX`: the left coordinate for region to render
-> Int32 | `destY`: the top coordinate for region to render
-> Int32 | `destWidth`: the width of the region to render
-> Int32 | `destHeight`: the height of the region to render
-> Double | `offsetX`: the offset in the X direction (currently rounded to an integer)
-> Double | `offsetY`: the offset in the Y direction (currently rounded to an integer)
-> Double | `scaleX`: the scale factor in the X direction
-> Double | `scaleY`: the scale factor in the Y direction
-> InterpType | `interpType`: the interpolation type for the transformation.
-> Int32 | `overallAlpha`: overall alpha for source image (0..255)
-> m () |

Creates a transformation of the source image `src` by scaling by `scaleX` and `scaleY` then translating by `offsetX` and `offsetY`.

This gives an image in the coordinates of the destination pixbuf. The rectangle (`destX`, `destY`, `destWidth`, `destHeight`) is then alpha blended onto the corresponding rectangle of the original destination image.

When the destination rectangle contains parts not in the source image, the data at the edges of the source image is replicated to infinity.

## compositeColor

pixbufCompositeColor Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `src`: a `Pixbuf`
-> b | `dest`: the `Pixbuf` into which to render the results
-> Int32 | `destX`: the left coordinate for region to render
-> Int32 | `destY`: the top coordinate for region to render
-> Int32 | `destWidth`: the width of the region to render
-> Int32 | `destHeight`: the height of the region to render
-> Double | `offsetX`: the offset in the X direction (currently rounded to an integer)
-> Double | `offsetY`: the offset in the Y direction (currently rounded to an integer)
-> Double | `scaleX`: the scale factor in the X direction
-> Double | `scaleY`: the scale factor in the Y direction
-> InterpType | `interpType`: the interpolation type for the transformation.
-> Int32 | `overallAlpha`: overall alpha for source image (0..255)
-> Int32 | `checkX`: the X offset for the checkboard (origin of checkboard is at -`checkX`, -`checkY`)
-> Int32 | `checkY`: the Y offset for the checkboard
-> Int32 | `checkSize`: the size of checks in the checkboard (must be a power of two)
-> Word32 | `color1`: the color of check at upper left
-> Word32 | `color2`: the color of the other check
-> m () |

Creates a transformation of the source image `src` by scaling by `scaleX` and `scaleY` then translating by `offsetX` and `offsetY`, then alpha blends the rectangle (`destX` ,`destY`, `destWidth`, `destHeight`) of the resulting image with a checkboard of the colors `color1` and `color2` and renders it onto the destination image.

If the source image has no alpha channel, and `overallAlpha` is 255, a fast path is used which omits the alpha blending and just performs the scaling.

See `pixbufCompositeColorSimple` for a simpler variant of this function suitable for many tasks.

## compositeColorSimple

pixbufCompositeColorSimple Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `src`: a `Pixbuf`
-> Int32 | `destWidth`: the width of destination image
-> Int32 | `destHeight`: the height of destination image
-> InterpType | `interpType`: the interpolation type for the transformation.
-> Int32 | `overallAlpha`: overall alpha for source image (0..255)
-> Int32 | `checkSize`: the size of checks in the checkboard (must be a power of two)
-> Word32 | `color1`: the color of check at upper left
-> Word32 | `color2`: the color of the other check
-> m (Maybe Pixbuf) | Returns: the new pixbuf

Creates a new pixbuf by scaling `src` to `dest_width` x `dest_height` and alpha blending the result with a checkboard of colors `color1` and `color2`.

## copy

pixbufCopy Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf

Creates a new `GdkPixbuf` with a copy of the information in the specified `pixbuf`.

Note that this does not copy the options set on the original `GdkPixbuf`, use `pixbufCopyOptions` for this.

## copyArea

pixbufCopyArea Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `srcPixbuf`: Source pixbuf.
-> Int32 | `srcX`: Source X coordinate within `srcPixbuf`.
-> Int32 | `srcY`: Source Y coordinate within `srcPixbuf`.
-> Int32 | `width`: Width of the area to copy.
-> Int32 | `height`: Height of the area to copy.
-> b | `destPixbuf`: Destination pixbuf.
-> Int32 | `destX`: X coordinate within `destPixbuf`.
-> Int32 | `destY`: Y coordinate within `destPixbuf`.
-> m () |

Copies a rectangular area from `src_pixbuf` to `dest_pixbuf`.

Conversion of pixbuf formats is done automatically.

If the source rectangle overlaps the destination rectangle on the same pixbuf, it will be overwritten during the copy operation. Therefore, you can not use this function to scroll a pixbuf.

## copyOptions

pixbufCopyOptions Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `srcPixbuf`: the source pixbuf
-> b | `destPixbuf`: the destination pixbuf
-> m Bool | Returns: `TRUE` on success.

Copies the key/value pair options attached to a `GdkPixbuf` to another `GdkPixbuf`.

This is useful to keep original metadata after having manipulated a file. However be careful to remove metadata which you've already applied, such as the "orientation" option after rotating the image.

Since: 2.36

## fill

pixbufFill Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`
-> Word32 | `pixel`: RGBA pixel to used to clear (`0xffffffff` is opaque white, `0x00000000` transparent black)
-> m () |

Clears a pixbuf to the given RGBA value, converting the RGBA value into the pixbuf's pixel format.

The alpha component will be ignored if the pixbuf doesn't have an alpha channel.

## flip

pixbufFlip Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `src`: a `Pixbuf`
-> Bool | `horizontal`: `TRUE` to flip horizontally, `FALSE` to flip vertically
-> m (Maybe Pixbuf) | Returns: the new pixbuf

Flips a pixbuf horizontally or vertically and returns the result in a new pixbuf.

Since: 2.6

## getBitsPerSample

pixbufGetBitsPerSample Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Int32 | Returns: Number of bits per color sample.

Queries the number of bits per color sample in a pixbuf.

## getByteLength

pixbufGetByteLength Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf
-> m CSize | Returns: The length of the pixel data.

Returns the length of the pixel data, in bytes.

Since: 2.26

## getColorspace

pixbufGetColorspace Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Colorspace | Returns: Color space.

Queries the color space of a pixbuf.

## getFileInfo

pixbufGetFileInfo Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Char] | `filename`: The name of the file to identify.
-> m (Maybe PixbufFormat, Int32, Int32) | Returns: A `GdkPixbufFormat` describing the image format of the file

Parses an image file far enough to determine its format and size.

Since: 2.4

## getFileInfoAsync

pixbufGetFileInfoAsync Source #

Arguments

:: (HasCallStack, MonadIO m, IsCancellable a) |
=> [Char] | `filename`: The name of the file to identify
-> Maybe a | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> Maybe AsyncReadyCallback | `callback`: a `GAsyncReadyCallback` to call when the file info is available
-> m () |

Asynchronously parses an image file far enough to determine its format and size.

For more details see `pixbufGetFileInfo`, which is the synchronous version of this function.

When the operation is finished, `callback` will be called in the main thread. You can then call `pixbufGetFileInfoFinish` to get the result of the operation.

Since: 2.32

## getFileInfoFinish

pixbufGetFileInfoFinish Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `asyncResult`: a `GAsyncResult`
-> m (Maybe PixbufFormat, Int32, Int32) | Returns: A `GdkPixbufFormat` describing the image format of the file (Can throw `GError`)

Finishes an asynchronous pixbuf parsing operation started with `pixbufGetFileInfoAsync`.

Since: 2.32

## getFormats

pixbufGetFormats Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m [PixbufFormat] | Returns: A list of support image formats.

Obtains the available information about the image formats supported by GdkPixbuf.

Since: 2.2

## getHasAlpha

pixbufGetHasAlpha Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Bool | Returns: `TRUE` if it has an alpha channel, `FALSE` otherwise.

Queries whether a pixbuf has an alpha channel (opacity information).

## getHeight

pixbufGetHeight Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Int32 | Returns: Height in pixels.

Queries the height of a pixbuf.

## getNChannels

pixbufGetNChannels Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Int32 | Returns: Number of channels.

Queries the number of channels of a pixbuf.

## getOption

pixbufGetOption Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`
-> Text | `key`: a nul-terminated string.
-> m (Maybe Text) | Returns: the value associated with `key`

Looks up `key` in the list of options that may have been attached to the `pixbuf` when it was loaded, or that may have been attached by another function using `pixbufSetOption`.

For instance, the ANI loader provides "Title" and "Artist" options. The ICO, XBM, and XPM loaders provide "x_hot" and "y_hot" hot-spot options for cursor definitions. The PNG loader provides the tEXt ancillary chunk key/value pairs as options. Since 2.12, the TIFF and JPEG loaders return an "orientation" option string that corresponds to the embedded TIFF/Exif orientation tag (if present). Since 2.32, the TIFF loader sets the "multipage" option string to "yes" when a multi-page TIFF is loaded. Since 2.32 the JPEG and PNG loaders set "x-dpi" and "y-dpi" if the file contains image density information in dots per inch. Since 2.36.6, the JPEG loader sets the "comment" option with the comment EXIF tag.

## getPixels

pixbufGetPixels Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m ByteString | Returns: A pointer to the pixbuf's pixel data.

Queries a pointer to the pixel data of a pixbuf.

This function will cause an implicit copy of the pixbuf data if the pixbuf was created from read-only data.

Please see the section on image data for information about how the pixel data is stored in memory.

Since: 2.26

## getRowstride

pixbufGetRowstride Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Int32 | Returns: Distance between row starts.

Queries the rowstride of a pixbuf, which is the number of bytes between the start of a row and the start of the next row.

## getWidth

pixbufGetWidth Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf.
-> m Int32 | Returns: Width in pixels.

Queries the width of a pixbuf.

## initModules

pixbufInitModules Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `path`: Path to directory where the `loaders.cache` is installed
-> m () | (Can throw `GError`)

Initalizes the gdk-pixbuf loader modules referenced by the `loaders.cache` file present inside that directory.

This is to be used by applications that want to ship certain loaders in a different location from the system ones.

This is needed when the OS or runtime ships a minimal number of loaders so as to reduce the potential attack surface of carefully crafted image files, especially for uncommon file types. Applications that require broader image file types coverage, such as image viewers, would be expected to ship the gdk-pixbuf modules in a separate location, bundled with the application in a separate directory from the OS or runtime- provided modules.

Since: 2.40

## new

pixbufNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Colorspace | `colorspace`: Color space for image
-> Bool | `hasAlpha`: Whether the image should have transparency information
-> Int32 | `bitsPerSample`: Number of bits per color sample
-> Int32 | `width`: Width of image in pixels, must be > 0
-> Int32 | `height`: Height of image in pixels, must be > 0
-> m (Maybe Pixbuf) | Returns: A newly-created pixel buffer

Creates a new `GdkPixbuf` structure and allocates a buffer for it.

If the allocation of the buffer failed, this function will return `NULL`.

The buffer has an optimal rowstride. Note that the buffer is not cleared; you will have to fill it completely yourself.

## newFromBytes

pixbufNewFromBytes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Bytes | `data`: Image data in 8-bit/sample packed format inside a `Bytes`
-> Colorspace | `colorspace`: Colorspace for the image data
-> Bool | `hasAlpha`: Whether the data has an opacity channel
-> Int32 | `bitsPerSample`: Number of bits per sample
-> Int32 | `width`: Width of the image in pixels, must be > 0
-> Int32 | `height`: Height of the image in pixels, must be > 0
-> Int32 | `rowstride`: Distance in bytes between row starts
-> m Pixbuf | Returns: A newly-created pixbuf

Creates a new `Pixbuf` out of in-memory readonly image data.

Currently only RGB images with 8 bits per sample are supported.

This is the `GBytes` variant of `pixbufNewFromData`, useful for language bindings.

Since: 2.32

## newFromData

pixbufNewFromData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Ptr Word8 | `data`: Image data in 8-bit/sample packed format
-> Colorspace | `colorspace`: Colorspace for the image data
-> Bool | `hasAlpha`: Whether the data has an opacity channel
-> Int32 | `bitsPerSample`: Number of bits per sample
-> Int32 | `width`: Width of the image in pixels, must be > 0
-> Int32 | `height`: Height of the image in pixels, must be > 0
-> Int32 | `rowstride`: Distance in bytes between row starts
-> Maybe PixbufDestroyNotify | `destroyFn`: Function used to free the data when the pixbuf's reference count drops to zero, or `NULL` if the data should not be freed
-> m Pixbuf | Returns: A newly-created pixbuf

Creates a new `Pixbuf` out of in-memory image data.

Currently only RGB images with 8 bits per sample are supported.

Since you are providing a pre-allocated pixel buffer, you must also specify a way to free that data. This is done with a function of type `GdkPixbufDestroyNotify`. When a pixbuf created with is finalized, your destroy notification function will be called, and it is its responsibility to free the pixel array.

See also: `pixbufNewFromBytes`

## newFromFile

pixbufNewFromFile Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Char] | `filename`: Name of file to load, in the GLib file name encoding
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from a file.

The file format is detected automatically.

If `NULL` is returned, then `error` will be set. Possible errors are:

- the file could not be opened
- there is no loader for the file's format
- there is not enough memory to allocate the image buffer
- the image buffer contains invalid data

The error domains are `GDK_PIXBUF_ERROR` and `G_FILE_ERROR`.

## newFromFileAtScale

pixbufNewFromFileAtScale Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Char] | `filename`: Name of file to load, in the GLib file name encoding
-> Int32 | `width`: The width the image should have or -1 to not constrain the width
-> Int32 | `height`: The height the image should have or -1 to not constrain the height
-> Bool | `preserveAspectRatio`: `TRUE` to preserve the image's aspect ratio
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from a file.

The file format is detected automatically.

If `NULL` is returned, then `error` will be set. Possible errors are:

- the file could not be opened
- there is no loader for the file's format
- there is not enough memory to allocate the image buffer
- the image buffer contains invalid data

The error domains are `GDK_PIXBUF_ERROR` and `G_FILE_ERROR`.

The image will be scaled to fit in the requested size, optionally preserving the image's aspect ratio.

When preserving the aspect ratio, a `width` of -1 will cause the image to be scaled to the exact given height, and a `height` of -1 will cause the image to be scaled to the exact given width. When not preserving aspect ratio, a `width` or `height` of -1 means to not scale the image at all in that dimension. Negative values for `width` and `height` are allowed since 2.8.

Since: 2.6

## newFromFileAtSize

pixbufNewFromFileAtSize Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Char] | `filename`: Name of file to load, in the GLib file name encoding
-> Int32 | `width`: The width the image should have or -1 to not constrain the width
-> Int32 | `height`: The height the image should have or -1 to not constrain the height
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from a file.

The file format is detected automatically.

If `NULL` is returned, then `error` will be set. Possible errors are:

- the file could not be opened
- there is no loader for the file's format
- there is not enough memory to allocate the image buffer
- the image buffer contains invalid data

The error domains are `GDK_PIXBUF_ERROR` and `G_FILE_ERROR`.

The image will be scaled to fit in the requested size, preserving the image's aspect ratio. Note that the returned pixbuf may be smaller than `width` x `height`, if the aspect ratio requires it. To load and image at the requested size, regardless of aspect ratio, use `pixbufNewFromFileAtScale`.

Since: 2.4

## newFromInline

pixbufNewFromInline Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ByteString | `data`: Byte data containing a serialized `GdkPixdata` structure
-> Bool | `copyPixels`: Whether to copy the pixel data, or use direct pointers `data` for the resulting pixbuf
-> m Pixbuf | Returns: A newly-created pixbuf (Can throw `GError`)

Deprecated: (Since version 2.32)Use `GResource` instead.

Creates a `GdkPixbuf` from a flat representation that is suitable for storing as inline data in a program.

This is useful if you want to ship a program with images, but don't want to depend on any external files.

GdkPixbuf ships with a program called `gdk-pixbuf-csource`, which allows for conversion of `GdkPixbuf`s into such a inline representation.

In almost all cases, you should pass the `--raw` option to `gdk-pixbuf-csource`. A sample invocation would be:

    gdk-pixbuf-csource --raw --name=myimage_inline myimage.png

For the typical case where the inline pixbuf is read-only static data, you don't need to copy the pixel data unless you intend to write to it, so you can pass `FALSE` for `copy_pixels`. If you pass `--rle` to `gdk-pixbuf-csource`, a copy will be made even if `copy_pixels` is `FALSE`, so using this option is generally a bad idea.

If you create a pixbuf from const inline data compiled into your program, it's probably safe to ignore errors and disable length checks, since things will always succeed:

### c code

    pixbuf = gdk_pixbuf_new_from_inline (-1, myimage_inline, FALSE, NULL);

For non-const inline data, you could get out of memory. For untrusted inline data located at runtime, you could have corrupt inline data in addition.

## newFromResource

pixbufNewFromResource Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `resourcePath`: the path of the resource file
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from an resource.

The file format is detected automatically. If `NULL` is returned, then `error` will be set.

Since: 2.26

## newFromResourceAtScale

pixbufNewFromResourceAtScale Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `resourcePath`: the path of the resource file
-> Int32 | `width`: The width the image should have or -1 to not constrain the width
-> Int32 | `height`: The height the image should have or -1 to not constrain the height
-> Bool | `preserveAspectRatio`: `TRUE` to preserve the image's aspect ratio
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from an resource.

The file format is detected automatically. If `NULL` is returned, then `error` will be set.

The image will be scaled to fit in the requested size, optionally preserving the image's aspect ratio. When preserving the aspect ratio, a `width` of -1 will cause the image to be scaled to the exact given height, and a `height` of -1 will cause the image to be scaled to the exact given width. When not preserving aspect ratio, a `width` or `height` of -1 means to not scale the image at all in that dimension.

The stream is not closed.

Since: 2.26

## newFromStream

pixbufNewFromStream Source #

Arguments

:: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) |
=> a | `stream`: a `GInputStream` to load the pixbuf from
-> Maybe b | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from an input stream.

The file format is detected automatically.

If `NULL` is returned, then `error` will be set.

The `cancellable` can be used to abort the operation from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. Other possible errors are in the `GDK_PIXBUF_ERROR` and `G_IO_ERROR` domains.

The stream is not closed.

Since: 2.14

## newFromStreamAsync

pixbufNewFromStreamAsync Source #

Arguments

:: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) |
=> a | `stream`: a `GInputStream` from which to load the pixbuf
-> Maybe b | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> Maybe AsyncReadyCallback | `callback`: a `GAsyncReadyCallback` to call when the pixbuf is loaded
-> m () |

Creates a new pixbuf by asynchronously loading an image from an input stream.

For more details see `pixbufNewFromStream`, which is the synchronous version of this function.

When the operation is finished, `callback` will be called in the main thread. You can then call `pixbufNewFromStreamFinish` to get the result of the operation.

Since: 2.24

## newFromStreamAtScale

pixbufNewFromStreamAtScale Source #

Arguments

:: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) |
=> a | `stream`: a `GInputStream` to load the pixbuf from
-> Int32 | `width`: The width the image should have or -1 to not constrain the width
-> Int32 | `height`: The height the image should have or -1 to not constrain the height
-> Bool | `preserveAspectRatio`: `TRUE` to preserve the image's aspect ratio
-> Maybe b | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf (Can throw `GError`)

Creates a new pixbuf by loading an image from an input stream.

The file format is detected automatically. If `NULL` is returned, then `error` will be set. The `cancellable` can be used to abort the operation from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. Other possible errors are in the `GDK_PIXBUF_ERROR` and `G_IO_ERROR` domains.

The image will be scaled to fit in the requested size, optionally preserving the image's aspect ratio.

When preserving the aspect ratio, a `width` of -1 will cause the image to be scaled to the exact given height, and a `height` of -1 will cause the image to be scaled to the exact given width. If both `width` and `height` are given, this function will behave as if the smaller of the two values is passed as -1.

When not preserving aspect ratio, a `width` or `height` of -1 means to not scale the image at all in that dimension.

The stream is not closed.

Since: 2.14

## newFromStreamAtScaleAsync

pixbufNewFromStreamAtScaleAsync Source #

Arguments

:: (HasCallStack, MonadIO m, IsInputStream a, IsCancellable b) |
=> a | `stream`: a `GInputStream` from which to load the pixbuf
-> Int32 | `width`: the width the image should have or -1 to not constrain the width
-> Int32 | `height`: the height the image should have or -1 to not constrain the height
-> Bool | `preserveAspectRatio`: `TRUE` to preserve the image's aspect ratio
-> Maybe b | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> Maybe AsyncReadyCallback | `callback`: a `GAsyncReadyCallback` to call when the pixbuf is loaded
-> m () |

Creates a new pixbuf by asynchronously loading an image from an input stream.

For more details see `pixbufNewFromStreamAtScale`, which is the synchronous version of this function.

When the operation is finished, `callback` will be called in the main thread. You can then call `pixbufNewFromStreamFinish` to get the result of the operation.

Since: 2.24

## newFromStreamFinish

pixbufNewFromStreamFinish Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `asyncResult`: a `GAsyncResult`
-> m (Maybe Pixbuf) | Returns: the newly created pixbuf (Can throw `GError`)

Finishes an asynchronous pixbuf creation operation started with `pixbufNewFromStreamAsync`.

Since: 2.24

## newFromXpmData

pixbufNewFromXpmData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Text] | `data`: Pointer to inline XPM data.
-> m (Maybe Pixbuf) | Returns: A newly-created pixbuf

Deprecated: (Since version 2.44)Use `pixbufNewFromStream` witha `MemoryInputStream`, making sure to handle errors incase the XPM format loader is not available

Creates a new pixbuf by parsing XPM data in memory.

This data is commonly the result of including an XPM file into a program's C source.

## newSubpixbuf

pixbufNewSubpixbuf Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `srcPixbuf`: a `GdkPixbuf`
-> Int32 | `srcX`: X coord in `srcPixbuf`
-> Int32 | `srcY`: Y coord in `srcPixbuf`
-> Int32 | `width`: width of region in `srcPixbuf`
-> Int32 | `height`: height of region in `srcPixbuf`
-> m Pixbuf | Returns: a new pixbuf

Creates a new pixbuf which represents a sub-region of `src_pixbuf`.

The new pixbuf shares its pixels with the original pixbuf, so writing to one affects both. The new pixbuf holds a reference to `src_pixbuf`, so `src_pixbuf` will not be finalized until the new pixbuf is finalized.

Note that if `src_pixbuf` is read-only, this function will force it to be mutable.

## readPixelBytes

pixbufReadPixelBytes Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf
-> m Bytes | Returns: A new reference to a read-only copy of the pixel data. Note that for mutable pixbufs, this function will incur a one-time copy of the pixel data for conversion into the returned `Bytes`.

Provides a `Bytes` buffer containing the raw pixel data; the data must not be modified.

This function allows skipping the implicit copy that must be made if `gdk_pixbuf_get_pixels()` is called on a read-only pixbuf.

Since: 2.32

## readPixels

pixbufReadPixels Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: A pixbuf
-> m Word8 | Returns: a read-only pointer to the raw pixel data

Provides a read-only pointer to the raw pixel data.

This function allows skipping the implicit copy that must be made if `gdk_pixbuf_get_pixels()` is called on a read-only pixbuf.

Since: 2.32

## removeOption

pixbufRemoveOption Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`
-> Text | `key`: a nul-terminated string representing the key to remove.
-> m Bool | Returns: `TRUE` if an option was removed, `FALSE` if not.

Removes the key/value pair option attached to a `GdkPixbuf`.

Since: 2.36

## rotateSimple

pixbufRotateSimple Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `src`: a `Pixbuf`
-> PixbufRotation | `angle`: the angle to rotate by
-> m (Maybe Pixbuf) | Returns: the new pixbuf

Rotates a pixbuf by a multiple of 90 degrees, and returns the result in a new pixbuf.

If `angle` is 0, this function will return a copy of `src`.

Since: 2.6

## saturateAndPixelate

pixbufSaturateAndPixelate Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `src`: source image
-> b | `dest`: place to write modified version of `src`
-> Float | `saturation`: saturation factor
-> Bool | `pixelate`: whether to pixelate
-> m () |

Modifies saturation and optionally pixelates `src`, placing the result in `dest`.

The `src` and `dest` pixbufs must have the same image format, size, and rowstride.

The `src` and `dest` arguments may be the same pixbuf with no ill effects.

If `saturation` is 1.0 then saturation is not changed. If it's less than 1.0, saturation is reduced (the image turns toward grayscale); if greater than 1.0, saturation is increased (the image gets more vivid colors).

If `pixelate` is `TRUE`, then pixels are faded in a checkerboard pattern to create a pixelated image.

## saveToBufferv

pixbufSaveToBufferv Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`.
-> Text | `type`: name of file format.
-> Maybe [Text] | `optionKeys`: name of options to set
-> Maybe [Text] | `optionValues`: values for named options
-> m ByteString | (Can throw `GError`)

Vector version of `gdk_pixbuf_save_to_buffer()`.

Saves pixbuf to a new buffer in format `type`, which is currently "jpeg", "tiff", "png", "ico" or "bmp".

See `Pixbuf`.`save_to_buffer`() for more details.

Since: 2.4

## saveToCallbackv

pixbufSaveToCallbackv Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`
-> PixbufSaveFunc | `saveFunc`: a function that is called to save each block of data that the save routine generates
-> Text | `type`: name of file format
-> Maybe [Text] | `optionKeys`: name of options to set
-> Maybe [Text] | `optionValues`: values for named options
-> m () | (Can throw `GError`)

Vector version of `gdk_pixbuf_save_to_callback()`.

Saves pixbuf to a callback in format `type`, which is currently "jpeg", "png", "tiff", "ico" or "bmp".

If `error` is set, `FALSE` will be returned.

See `Pixbuf`.`save_to_callback`() for more details.

Since: 2.4

## saveToStreamFinish

pixbufSaveToStreamFinish Source #

Arguments

:: (HasCallStack, MonadIO m, IsAsyncResult a) |
=> a | `asyncResult`: a `GAsyncResult`
-> m () | (Can throw `GError`)

Finishes an asynchronous pixbuf save operation started with `gdk_pixbuf_save_to_stream_async()`.

Since: 2.24

## saveToStreamv

pixbufSaveToStreamv Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsOutputStream b, IsCancellable c) |
=> a | `pixbuf`: a `GdkPixbuf`
-> b | `stream`: a `GOutputStream` to save the pixbuf to
-> Text | `type`: name of file format
-> Maybe [Text] | `optionKeys`: name of options to set
-> Maybe [Text] | `optionValues`: values for named options
-> Maybe c | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> m () | (Can throw `GError`)

Saves `pixbuf` to an output stream.

Supported file formats are currently "jpeg", "tiff", "png", "ico" or "bmp".

See `Pixbuf`.`save_to_stream`() for more details.

Since: 2.36

## saveToStreamvAsync

pixbufSaveToStreamvAsync Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsOutputStream b, IsCancellable c) |
=> a | `pixbuf`: a `GdkPixbuf`
-> b | `stream`: a `GOutputStream` to which to save the pixbuf
-> Text | `type`: name of file format
-> Maybe [Text] | `optionKeys`: name of options to set
-> Maybe [Text] | `optionValues`: values for named options
-> Maybe c | `cancellable`: optional `GCancellable` object, `NULL` to ignore
-> Maybe AsyncReadyCallback | `callback`: a `GAsyncReadyCallback` to call when the pixbuf is saved
-> m () |

Saves `pixbuf` to an output stream asynchronously.

For more details see `pixbufSaveToStreamv`, which is the synchronous version of this function.

When the operation is finished, `callback` will be called in the main thread.

You can then call `pixbufSaveToStreamFinish` to get the result of the operation.

Since: 2.36

## savev

pixbufSavev Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`.
-> [Char] | `filename`: name of file to save.
-> Text | `type`: name of file format.
-> Maybe [Text] | `optionKeys`: name of options to set
-> Maybe [Text] | `optionValues`: values for named options
-> m () | (Can throw `GError`)

Vector version of `gdk_pixbuf_save()`.

Saves pixbuf to a file in `type`, which is currently "jpeg", "png", "tiff", "ico" or "bmp".

If `error` is set, `FALSE` will be returned.

See `Pixbuf`.`save`() for more details.

## scale

pixbufScale Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a, IsPixbuf b) |
=> a | `src`: a `Pixbuf`
-> b | `dest`: the `Pixbuf` into which to render the results
-> Int32 | `destX`: the left coordinate for region to render
-> Int32 | `destY`: the top coordinate for region to render
-> Int32 | `destWidth`: the width of the region to render
-> Int32 | `destHeight`: the height of the region to render
-> Double | `offsetX`: the offset in the X direction (currently rounded to an integer)
-> Double | `offsetY`: the offset in the Y direction (currently rounded to an integer)
-> Double | `scaleX`: the scale factor in the X direction
-> Double | `scaleY`: the scale factor in the Y direction
-> InterpType | `interpType`: the interpolation type for the transformation.
-> m () |

Creates a transformation of the source image `src` by scaling by `scaleX` and `scaleY` then translating by `offsetX` and `offsetY`, then renders the rectangle (`destX`, `destY`, `destWidth`, `destHeight`) of the resulting image onto the destination image replacing the previous contents.

Try to use `pixbufScaleSimple` first; this function is the industrial-strength power tool you can fall back to, if `pixbufScaleSimple` isn't powerful enough.

If the source rectangle overlaps the destination rectangle on the same pixbuf, it will be overwritten during the scaling which results in rendering artifacts.

## scaleSimple

pixbufScaleSimple Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `src`: a `Pixbuf`
-> Int32 | `destWidth`: the width of destination image
-> Int32 | `destHeight`: the height of destination image
-> InterpType | `interpType`: the interpolation type for the transformation.
-> m (Maybe Pixbuf) | Returns: the new pixbuf

Create a new pixbuf containing a copy of `src` scaled to `dest_width` x `dest_height`.

This function leaves `src` unaffected.

The `interp_type` should be `GDK_INTERP_NEAREST` if you want maximum speed (but when scaling down `GDK_INTERP_NEAREST` is usually unusably ugly). The default `interp_type` should be `GDK_INTERP_BILINEAR` which offers reasonable quality and speed.

You can scale a sub-portion of `src` by creating a sub-pixbuf pointing into `src`; see `pixbufNewSubpixbuf`.

If `dest_width` and `dest_height` are equal to the width and height of `src`, this function will return an unscaled copy of `src`.

For more complicated scaling/alpha blending see `pixbufScale` and `pixbufComposite`.

## setOption

pixbufSetOption Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbuf a) |
=> a | `pixbuf`: a `GdkPixbuf`
-> Text | `key`: a nul-terminated string.
-> Text | `value`: a nul-terminated string.
-> m Bool | Returns: `TRUE` on success

Attaches a key/value pair as an option to a `GdkPixbuf`.

If `key` already exists in the list of options attached to the `pixbuf`, the new value is ignored and `FALSE` is returned.

Since: 2.2

# Properties

## bitsPerSample

The number of bits per sample.

Currently only 8 bit per sample are supported.

constructPixbufBitsPerSample :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`bits-per-sample`” property. This is rarely needed directly, but it is used by `new`.

getPixbufBitsPerSample :: (MonadIO m, IsPixbuf o) => o -> m Int32 Source #

Get the value of the “`bits-per-sample`” property. When overloading is enabled, this is equivalent to

    get pixbuf #bitsPerSample

## colorspace

The color space of the pixbuf.

Currently, only `GDK_COLORSPACE_RGB` is supported.

constructPixbufColorspace :: (IsPixbuf o, MonadIO m) => Colorspace -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`colorspace`” property. This is rarely needed directly, but it is used by `new`.

getPixbufColorspace :: (MonadIO m, IsPixbuf o) => o -> m Colorspace Source #

Get the value of the “`colorspace`” property. When overloading is enabled, this is equivalent to

    get pixbuf #colorspace

## hasAlpha

Whether the pixbuf has an alpha channel.

constructPixbufHasAlpha :: (IsPixbuf o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`has-alpha`” property. This is rarely needed directly, but it is used by `new`.

getPixbufHasAlpha :: (MonadIO m, IsPixbuf o) => o -> m Bool Source #

Get the value of the “`has-alpha`” property. When overloading is enabled, this is equivalent to

    get pixbuf #hasAlpha

## height

The number of rows of the pixbuf.

constructPixbufHeight :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`height`” property. This is rarely needed directly, but it is used by `new`.

getPixbufHeight :: (MonadIO m, IsPixbuf o) => o -> m Int32 Source #

Get the value of the “`height`” property. When overloading is enabled, this is equivalent to

    get pixbuf #height

## nChannels

The number of samples per pixel.

Currently, only 3 or 4 samples per pixel are supported.

constructPixbufNChannels :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`n-channels`” property. This is rarely needed directly, but it is used by `new`.

getPixbufNChannels :: (MonadIO m, IsPixbuf o) => o -> m Int32 Source #

Get the value of the “`n-channels`” property. When overloading is enabled, this is equivalent to

    get pixbuf #nChannels

## pixelBytes

No description available in the introspection data.

constructPixbufPixelBytes :: (IsPixbuf o, MonadIO m) => Bytes -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`pixel-bytes`” property. This is rarely needed directly, but it is used by `new`.

getPixbufPixelBytes :: (MonadIO m, IsPixbuf o) => o -> m (Maybe Bytes) Source #

Get the value of the “`pixel-bytes`” property. When overloading is enabled, this is equivalent to

    get pixbuf #pixelBytes

## pixels

A pointer to the pixel data of the pixbuf.

constructPixbufPixels :: (IsPixbuf o, MonadIO m) => Ptr () -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`pixels`” property. This is rarely needed directly, but it is used by `new`.

getPixbufPixels :: (MonadIO m, IsPixbuf o) => o -> m (Ptr ()) Source #

Get the value of the “`pixels`” property. When overloading is enabled, this is equivalent to

    get pixbuf #pixels

## rowstride

The number of bytes between the start of a row and the start of the next row.

This number must (obviously) be at least as large as the width of the pixbuf.

constructPixbufRowstride :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`rowstride`” property. This is rarely needed directly, but it is used by `new`.

getPixbufRowstride :: (MonadIO m, IsPixbuf o) => o -> m Int32 Source #

Get the value of the “`rowstride`” property. When overloading is enabled, this is equivalent to

    get pixbuf #rowstride

## width

The number of columns of the pixbuf.

constructPixbufWidth :: (IsPixbuf o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`width`” property. This is rarely needed directly, but it is used by `new`.

getPixbufWidth :: (MonadIO m, IsPixbuf o) => o -> m Int32 Source #

Get the value of the “`width`” property. When overloading is enabled, this is equivalent to

    get pixbuf #width